#include <windows.h>
#include <stdio.h>
#include <gl/glut.h>
#include "main.h"
#include "3dsloader.h"
#include "texture.h"

GLuint textures[2];

int screen_width = 640;
int screen_height = 480;
float rotation_x = 0, rotation_x_increment = 0.1;
float rotation_y = 0, rotation_y_increment = 0.05;
float rotation_z = 0, rotation_z_increment = 0.03;

obj_type object;

void init()
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glShadeModel(GL_SMOOTH);
	glViewport(0, 0, screen_width, screen_height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0, float(screen_width) / float(screen_height), 10.0, 10000.0);
	glEnable(GL_DEPTH_TEST);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glEnable(GL_TEXTURE_2D);
	Load3DS(&object, "a.3ds");

	/*
	object.id_texture = LoadBitmap("a.bmp");

	if (object.id_texture == -1)
    {
		printf("Image file: spaceshiptexture.bmp not found\n");
        exit (0);
    }
*/
}

void reshape(int w, int h)
{
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0, float(w) / float(h), 10.0, 10000.0);
}

void display()
{
	int l_index;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glTranslatef(0.0, 0.0, -300.0);

	rotation_x = rotation_x + rotation_x_increment;
	rotation_y = rotation_y + rotation_y_increment;
	rotation_z = rotation_z + rotation_z_increment;
	
	if(rotation_x > 359) rotation_x = 0;
	if(rotation_y > 359) rotation_y = 0;
	if(rotation_z > 359) rotation_z = 0;
	
	glRotatef(rotation_x, 1.0, 0.0, 0.0);
	glRotatef(rotation_y, 0.0, 1.0, 0.0);
	glRotatef(rotation_z, 0.0, 0.0, 1.0);

	glBindTexture(GL_TEXTURE_2D, object.id_texture);
	
	glBegin(GL_TRIANGLES);
	for(l_index = 0; l_index < object.polygons_qty; l_index++)
	{
		glTexCoord2f(object.mapcoord[object.polygon[l_index].a].u,
					 object.mapcoord[object.polygon[l_index].a].v);
		glVertex3f(object.vertex[object.polygon[l_index].a].x,
				   object.vertex[object.polygon[l_index].a].y,
			       object.vertex[object.polygon[l_index].a].z);

		glTexCoord2f(object.mapcoord[object.polygon[l_index].b].u,
			         object.mapcoord[object.polygon[l_index].b].v);
		glVertex3f(object.vertex[object.polygon[l_index].b].x,
			       object.vertex[object.polygon[l_index].b].y,
			       object.vertex[object.polygon[l_index].b].z);
		
		glTexCoord2f(object.mapcoord[object.polygon[l_index].c].u,
			         object.mapcoord[object.polygon[l_index].c].v);
		glVertex3f(object.vertex[object.polygon[l_index].c].x,
			       object.vertex[object.polygon[l_index].c].y,
			       object.vertex[object.polygon[l_index].c].z);
	}
	glEnd();

	glFlush();
	glutSwapBuffers();
}

int main()
{
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB);
	glutInitWindowSize(screen_width, screen_height);
	glutCreateWindow("opengl");
	glutDisplayFunc(display);
	glutIdleFunc(display);
	glutReshapeFunc(reshape);
	init();
	glutMainLoop();
}